#include "Semaphore.hh"

#include <iostream>
using namespace std;

Semaphore::Semaphore(int val)
: value_(val)
{
	wait_lock_.lock();
}


void Semaphore::wait() {
	value_lock_.lock();
	if(value_<=0) {
		value_--;
//		cerr << "Semaphore::wait(" << value_ << ")..." << endl;
		value_lock_.unlock();
		wait_lock_.lock();
	} else {
		value_--;
		value_lock_.unlock();
	}
}

void Semaphore::signal() {
	value_lock_.lock();
	if(value_<0) {
		value_++;
		value_lock_.unlock();
		wait_lock_.unlock();
	} else {
		value_++;
		value_lock_.unlock();
	}
}




